package com.flyfish.framework.mongodb.query.impl;

import com.flyfish.framework.domain.base.Domain;
import com.flyfish.framework.query.*;
import com.flyfish.framework.query.support.DomainFunction;

import java.util.List;
import java.util.function.Supplier;

/**
 * mongodb实现的基于lambda的查询链
 *
 * @author wangyu
 */
public class MongoLambdaQueryChain<T extends Domain> extends MongoQueryDefinition implements LambdaQueryChain<T> {

    /**
     * 以且连接下一个字段
     *
     * @param column 列
     * @return 查询条件
     */
    @Override
    public QueryCondition<LambdaQueryChain<T>> and(DomainFunction<T> column) {
        return null;
    }

    /**
     * 直接拼接提供者，此处懒加载，最终build才会执行
     *
     * @param supplier 提供者
     * @return 结果
     */
    @Override
    public <V extends QueryChain<V, ?>> LambdaQueryChain<T> and(Supplier<QueryChain<V, ?>> supplier) {
        return null;
    }

    /**
     * 条件列表
     *
     * @param chain 多个条件们
     * @return 结果
     */
    @Override
    public LambdaQueryChain<T> and(LambdaQueryChain<T> chain) {
        return null;
    }

    /**
     * 多个嵌套子条件列表
     *
     * @param lambdaQueryChains 多条链
     * @param combinator        各个链条之间的连接方式
     * @return 结果
     */
    @Override
    public LambdaQueryChain<T> and(List<LambdaQueryChain<T>> lambdaQueryChains, Queries.Combinator combinator) {
        return null;
    }

    /**
     * 以或连接下一个字段
     *
     * @param column 列
     * @return 查询条件
     */
    @Override
    public QueryCondition<LambdaQueryChain<T>> or(DomainFunction<T> column) {
        return null;
    }

    /**
     * 以或连接条件列表
     *
     * @param chain 多个条件们
     * @return 结果
     */
    @Override
    public LambdaQueryChain<T> or(LambdaQueryChain<T> chain) {
        return null;
    }

    /**
     * 以或连接嵌套多个子条件列表
     *
     * @param lambdaQueryChains 多条链
     * @param combinator        各个链条之间的连接方式
     * @return 结果
     */
    @Override
    public LambdaQueryChain<T> or(List<LambdaQueryChain<T>> lambdaQueryChains, Queries.Combinator combinator) {
        return null;
    }

    /**
     * 直接拼接提供者，此处懒加载，最终build才会执行
     *
     * @param supplier 提供者
     * @return 结果
     */
    @Override
    public <V extends QueryChain<V, ?>> LambdaQueryChain<T> or(Supplier<QueryChain<V, ?>> supplier) {
        return null;
    }
}
